---
title: Mobile accessibility checklist
slug: Web/Accessibility/Mobile_accessibility_checklist
tags:
  - Accessibility
  - Firefox OS
  - Guidelines
  - Mobile
  - checklist
---
<div class="summary">
<p><span class="seoSummary">This document provides a concise checklist of accessibility requirements for mobile app developers. It is intended to continuously evolve as more patterns arise.</span></p>
</div>

<h2 id="Colour">Color</h2>

<ul>
	<li>Color contrast must comply with <a href="https://www.w3.org/TR/WCAG/#contrast-minimum">WCAG 2.1 AA level requirements</a>:

	<ul>
		<li>Contrast ratio of 4.5:1 for normal text (less than 18 point or 14 point bold.)</li>
		<li>Contrast ratio of 3:1 for large text (at least 18 point or 14 point bold.)</li>
	</ul>
	</li>
	<li>Information conveyed via color must be also available by other means too (underlined text for links, etc.)</li>
</ul>

<h2 id="Visibility">Visibility</h2>

<ul>
	<li>Content hiding techniques such as zero opacity, z-index order and off-screen placement must not be used exclusively to handle visibility.</li>
	<li>Everything other than the currently visible screen must be <em>truly</em> invisible (especially relevant for single page apps with multiple <em>cards</em>):
	<ul>
		<li>Use the <code>hidden</code> attribute or <code>visibility</code> or <code>display</code> style properties.</li>
		<li>Unless absolutely unavoidable, <code>aria-hidden</code> attribute should not be used.</li>
	</ul>
	</li>
</ul>

<h2 id="Focus">Focus</h2>

<ul>
	<li>All activatable elements must be focusable:

	<ul>
		<li>Standard controls such as links, buttons, and form fields are focusable by default.</li>
		<li>Non-standard controls must have an appropriate <a href="/en-US/docs/Web/Accessibility/ARIA/Roles">ARIA Role</a> assigned to them, such as <code>button</code>, <code>link</code>, or <code>checkbox</code>.</li>
	</ul>
	</li>
	<li>Focus should be handled in a logical order and consistent manner.</li>
</ul>

<h2 id="Text_Equivalents">Text equivalents</h2>

<ul>
	<li>Text equivalent must be provided for every non-strictly presentational non-text element within the app.

	<ul>
		<li>Use <em>alt</em> and <em>title</em> where appropriate (<em>s</em>ee Steve Faulkner's post about <a href="http://blog.paciellogroup.com/2013/01/using-the-html-title-attribute-updated/">Using the HTML title attribute</a> for a good guide.)</li>
		<li>If the above attributes are not applicable, use appropriate <a href="https://www.w3.org/TR/wai-aria-1.1/#state_prop_def">ARIA States and Properties</a> such as <code>aria-label</code>, <code>aria-labelledby</code>, or <code>aria-describedby</code>.</li>
	</ul>
	</li>
	<li>Images of text must be avoided.</li>
	<li>All user interface components with visible text (or image of text) as labels must have the same text available in the programmatic <a href="https://www.w3.org/TR/WCAG21/#dfn-name">name</a> of the component. <a href="https://www.w3.org/WAI/WCAG21/Understanding/label-in-name.html">WCAG 2.1: Label in name.</a></li>
	<li>All form controls must have labels ({{ htmlelement("label") }} elements) for the benefit of screen reader users.</li>
</ul>

<h2 id="Handling_State">Handling state</h2>

<ul>
	<li>Standard controls such as radio buttons and checkboxes are handled by the operating system. However, for other custom controls state changes must be provided via <a href="https://www.w3.org/TR/wai-aria-1.1/#state_prop_def">ARIA States</a> such as<code> aria-checked</code>, <code>aria-disabled</code>, <code>aria-selected</code>, <code>aria-expanded</code>, and <code>aria-pressed</code>.</li>
</ul>

<h2 id="Orientation">Orientation</h2>

<ul>
	<li>Content should not be restricted to a single orientation, such as portrait or landscape, unless essential. <a href="https://www.w3.org/WAI/WCAG21/Understanding/orientation.html">WCAG 2.1: Orientation</a>

	<ul>
		<li>Examples of when an orientation is esssential is a piano application or a bank check.</li>
	</ul>
	</li>
</ul>

<h2 id="General_Guidelines">General guidelines</h2>

<ul>
	<li>An app title must be provided.</li>
	<li>Headings must not break hierarchical structure
	<pre class="brush: html notranslate">&lt;h1&gt;Top level heading&lt;/h1&gt;
  &lt;h2&gt;Secondary heading&lt;/h2&gt;
  &lt;h2&gt;Another secondary heading&lt;/h2&gt;
    &lt;h3&gt;Low level heading&lt;/h3&gt;</pre>
	</li>
	<li><a href="https://www.washington.edu/accessibility/web/landmarks/">ARIA Landmark Roles</a> should be used to describe an app or document structure, such as <code>banner</code>, <code>complementary</code>, <code>contentinfo</code>, <code>main</code>, <code>navigation</code>, <code>search</code>.</li>
	<li>For touch events, at least one of the following must be true (<a href="https://www.w3.org/WAI/WCAG21/Understanding/pointer-cancellation.html">WCAG 2.1: Pointer Cancellation</a>):
	<ul>
		<li>The down-event should not be used to trigger any action</li>
		<li>The action is triggered on the up event and an option to abort the action before its completion is available or an option to undo the action after its completion</li>
		<li>The up-event will undo any action that was triggered on a down event</li>
		<li>It is essential to trigger the action on the down event. For example, playing a game or a piano application.</li>
	</ul>
	</li>
	<li>Touch targets must be large enough for the user to interact with (see the <a href="http://www.bbc.co.uk/guidelines/futuremedia/accessibility/mobile/design/touch-target-size">BBC Mobile Accessibility Guidelines</a> for useful touch target size guidelines).</li>
</ul>

<div class="note">
<p><strong>Note</strong>: The <a href="https://yzen.github.io/firefoxos/2014/04/30/mobile-accessibility-checklist.html">original version of this document</a> was written by <a href="https://yzen.github.io/">Yura Zenevich</a>.</p>
</div>
